import {Component, OnInit} from '@angular/core';
import {SystemService} from '../../system.service';
import {NzMessageService} from 'ng-zorro-antd';

@Component({
    selector: 'smart-separation',
    templateUrl: './separation.component.html',
    styles: []
})
export class SeparationComponent implements OnInit {

    isVisible = false;
    title;
    list = [];
    value = 0;
    first = {
        id:"",
        value:null,
        check:null
    };

    constructor(private systemSer: SystemService,private message:NzMessageService) {
    }

    ngOnInit() {}

    //查询三员分立
    separationPowerStatus() {
        this.systemSer.separationPowers().subscribe(
            (res) => {
                if (res.errCode == 10000) {
                    this.first = res.data[0];
                    if(this.first.value == 0){
                        this.first.check = true;
                    }else{
                        this.first.check = false;
                    }
                    res.data.splice(0, 1);
                    this.list = res.data;
                    this.list.forEach(e=>{
                        if(e.value == 0){
                            e.check = true;
                        }else{
                            e.check = false;
                        }
                    })
                }
            }
        );
    }

    showModal(title) {
        this.title = title;
        this.isVisible = true;
        this.separationPowerStatus();
    }

    handleCancel() {
        this.isVisible = false;
    }

    //保存
    handleOk() {
        let arr = [];
        arr.push(this.first);
        arr = arr.concat(this.list);
      let arr1 = arr.map(res=>{
           const data = {
               id:res.id,
               value:null
           }
           if(res.check){
               data.value = 0;
           }else{
               data.value = 1;
           }
           return data;
       });
      this.systemSer.updateSeparationPowerStatus(arr1).subscribe(
          (res)=>{
              if(res.errCode == 10000){
                  if(this.first.check){
                      this.message.success("已开启三员分立功能");
                  }else{
                      this.message.success("已关闭三员分立功能");
                  }
                  this.isVisible = false;
              }else{
                  this.message.error(res.errMsg);
              }
          }
      )

    }

}
